$! 'f$verify(0)
$!
$!	IndexDemo.COM - for DTquery searches with DECthreads server
$!	=============
$!	19-AUG-1994	F.Macrides (macrides@sci.wfeb.edu)
$!			Example htbin script interface to the
$!			 VMSIndex search engine (DTquery.c) for
$!			 use with the OSU DECthreads httpd.
$!			Should be placed where your htbin
$!			 scripts have been mapped.
$!	16-OCT-1994	Added lots of symbol options (see below). - FM
$!	31-DEC-1994	Enhanced for DECthreads server v1.7. - FM
$!
$!	DTquery.c is my modification of Bruce Tanner's query.c (for the
$!	VMS gopherd) and my WWWquery.c (for the CERN httpd) for accessing
$!	foo.doc;*, foo.IDX;*, foo.SEL;* filesets.  The doc file(s) is(are)
$!	indexed with BUILD_INDEX.EXE, yielding the IDX and SEL filesets.
$!	This search engine was develeped by Bruce and colleagues associated
$!	with the VMSGopher-L@trln.lib.unc.edu list for use with the
$!	VMSGopherServer.  It is similar to WAIS, but uses native indexing
$!	facilities of the VMS Record Management System (RMS).
$!
$!	Get the BUILD_INDEX sources and support files as a zip archive in:
$!
$!		gopher://sci.wfeb.edu/11[_FileServ._HTTPD]
$!
$!	Read its BUILD_INDEX.DOC for information about the indexer.  The
$!	IDX and SEL files built by the indexer are the same whether they
$!	are intended for use by the Gopher or HTTP Servers, or from the
$!	DCL command line.
$!
$!	This example script is for use with the indexdemo.idx and .sel
$!	files distributed with the DECthreads server (and normally
$!	searched by Index_Search.exe on the document /www/indexdemo.html).
$!	Invoke this example script via the URL:
$!
$!		http://host[:port]/htbin/indexdemo
$!
$!	If no query was included in the client's request, a "database cover
$!	page" is returned.
$!
$!	Check the foreign command definition for DTquery, below, and point
$!	the symbol 'database' to the IndexDemo IDX/SEL file pair that is
$!	distributed with the DECthreads server.
$!
$!----------------------------------------------------------------------------
$ DTquery := "$WWW_Root:[Bin]DTquery"
$! -----------------------------------
$ database = "WWW_Root:[Documents]IndexDemo"
$!-------------------------------------------
$ say = "write net_link"
$ say "<DNETARG2>"	! Get the query string, if present.
$ read net_link query
$!
$ IF query .eqs. ""
$ THEN
$!
$!  No query string.  Send the Cover Page.
$!
$   say "<DNETID>"			! Construct the access symbol.
$   read net_link id
$   host = f$edit(f$element(1," ", id),"LOWERCASE")
$   port = ":" + f$element(2," ",id)
$   if port .eqs. ":80" .or. port .eqs. ": " then port = ""
$   access = "http://" + host + port
$   say "<DNETRECMODE>"			! Set IMPLIED CARRIAGE CONTROL.
$   say "<DNETCGI>"			! Set CGI environment.
$   crlf = f$fao("!/") 
$   say "Content-Type: text/html", crlf	! Send the Header.
$   create net_link			! Send the Cover Page.
<HTML>
<HEAD>
<TITLE>DTquery search demonstration for HTML file sets.</TITLE>
</HEAD>
<BODY>
<H1>Index searching</H1>
Keyword searches on documents can be performed by Index_Search.exe,
which uses special files, suffixed with .idx and .sel, that are
created by the <A HREF="gopher://sci.wfeb.edu/11%5b_FileServ._HTTPD%5d"
>VMSINDEX</A> program. The indexdemo.idx and indexdemo.sel files
distributed with the server are a combined keyword index of all HTML
files in the /www/ directory. Searching for a keyword on the
/www/indexdemo.html iSINDEX file is therefore effectively matching
keywords against all the foo.html files in the /www/ directory.
<P>
This cover page instead was created on the fly by the htbin script
IndexDemo.com, which will call DTquery.exe as the search engine, but
use the same .idx and .sel files as would Index_Search.exe. The two
search methods are equivalent for sets of whole foo.html files, but
with the DTquery.exe engine one can collect the .idx and .sel files
into any subdirectory and search various combinations of them by using
different foo.com scripts for creating appropriate cover pages for one
versus another combination of .idx and .sel sets.
<P>
$   say "Use <A HREF=""''access'/htbin/indexdemo?title"">title</A>"
$   create net_link
as the search term to get hits for all of the documents.
<ISINDEX>
<P>
</BODY>
</HTML>
$   say "</DNETCGI>"			! Send CGI environment end tag.
$ ELSE
$!
$!  Query string for a search or document fetch is present.
$!  Do the search or send the document.
$!
$!  Hit list options:
$!  =================
$   WWW_SEND_RAW_FILE = "TRUE"
$   WWW_SHOW_FILETYPE = "TRUE"	! Show filetype icons or ALT strings
$   WWW_MAXIMUM_HITS = 250	! Limit number of hits to return
$   WWW_SHOW_SIZE = "YES"	! Bytes or KB
$!  WWW_SHOW_DATE = "YES"	! DD-MMM-YY
$!  WWW_SHOW_TIME = "YES"	! Replace -YY with HH:MM for current year
$!  WWW_USE_MDATE = "YES"	! Use last modified date (default is creation)
$!
$   DTquery "''P1'" "''P2'" "''P3'" "''database'"
$ ENDIF
$ exit
